USE [FCCLOCAL]
GO

/*** All the SQL code is be colapsed down into one UpdateDatabase.sql Script ***/
/*** BEGIN CREATE TABLES SECTION ***/

if not exists (SELECT * FROM sys.tables WHERE name = N'WppRequest')	
BEGIN


	/****** Object:  Table [dbo].[WppOffline]    Script Date: 11/30/2015 9:05:07 AM ******/
	SET ANSI_NULLS ON
	
	SET QUOTED_IDENTIFIER ON
	
	SET ANSI_PADDING ON
	
	CREATE TABLE [dbo].[WppOffline](
		[Id] [bigint] IDENTITY(1,1) NOT NULL,
		[cardData] [varchar](max) NULL,
		[transRequest] [varchar](max) NULL,
		[dateUtc] [datetime] NULL,
		[errorCode] [int] NULL,
		[transactionId] [bigint] NOT NULL,
		[requestId] [varchar](max) NOT NULL,
		[approvalCode] [varchar](max) NULL,
		[requestType] bigint NULL,
		[tipAmount] smallmoney NULL
	PRIMARY KEY CLUSTERED 
	(
		[Id] ASC
	)
	)

	
	SET ANSI_PADDING OFF
	
	/****** Object:  Table [dbo].[WppOfflineDecline]    Script Date: 11/30/2015 9:05:07 AM ******/
	SET ANSI_NULLS ON
	
	SET QUOTED_IDENTIFIER ON
	
	SET ANSI_PADDING ON
	CREATE TABLE [dbo].[WppOfflineDecline](
		[Id] [bigint] IDENTITY(1,1) NOT NULL,
		[cardData] [varchar](max) NULL,
		[transRequest] [varchar](max) NULL,
		[dateUtc] [datetime] NULL,
		[transactionId] [bigint] NULL,
		[requestId] [varchar](max) NULL,
		[errorCode] [int] NULL,
		[approvalCode] [varchar](max) NULL,
		[requestType] bigint NULL
	PRIMARY KEY CLUSTERED 
	(
		[Id] ASC
	)
	)

	
	SET ANSI_PADDING OFF
	
	/****** Object:  Table [dbo].[WppRequest]    Script Date: 11/30/2015 9:05:07 AM ******/
	SET ANSI_NULLS ON
	
	SET QUOTED_IDENTIFIER ON
	
	SET ANSI_PADDING ON
	
	CREATE TABLE [dbo].[WppRequest](
		[Id] [bigint] IDENTITY(1,1) NOT NULL,
		[transactionId] [bigint] NULL,
		[requestId] [varchar](32) NULL,
		[merchantReferenceCode] [varchar](99) NULL,
		[approvalCode] [varchar](6) NULL,
		[approvedAmount] [smallmoney] NULL,
		[errorCode] [int] NULL,
		[transRequest] VARCHAR(max) NULL,
		[cardData] VARCHAR(max) NULL,
		[dateUtc] [datetime] NOT NULL DEFAULT (getutcdate()),
		[userData] [varchar](99) NULL,
		[tipAmount] smallmoney NULL,
		[isInitialRequest] bit NULL,
		[tor] bit NULL
	)

	
	SET ANSI_PADDING OFF
	
	/****** Object:  Table [dbo].[WppTransaction]    Script Date: 11/30/2015 9:05:07 AM ******/
	SET ANSI_NULLS ON
	
	SET QUOTED_IDENTIFIER ON
	
	SET ANSI_PADDING ON
	
	CREATE TABLE [dbo].[WppTransaction](
		[Id] [bigint] IDENTITY(1,1) NOT NULL,
		[requestId] [varchar](32) NULL,
		[folioDate] [datetime] NULL,
		[folioNumber] [varchar](50) NULL,
		[dateUtc] [datetime] NOT NULL CONSTRAINT [DF_Transaction_dateUtc]  DEFAULT (getutcdate()),
		[chipData] [varchar](max) NULL,
		[originalChipData] [varchar](max) NULL,
		[sigData] [varchar](max) NULL,
		[useDcc] [bit] NOT NULL CONSTRAINT [DF_Transaction_useDcc]  DEFAULT ((0)),
		[allowIncrAuth] [bit] NOT NULL CONSTRAINT [DF_Auth_allocIncrAuth]  DEFAULT ((1)),
		[emvTagData] [varchar](max) NULL,
		[storeId] [varchar](max) NULL,
		[terminalId] [varchar](max) NULL,
		[clientEnvironment] [varchar](max) NULL,
		[token] [varchar](max) NULL,
		[expiryDate] [varchar](4) NULL,
		[maskedCardNumber] [varchar](16) NULL,
		[cardType] [varchar](max) NULL,
		[offlineTrans] [bit] NULL,
		[cardData] [varchar](max) NULL
	) 

	
	SET ANSI_PADDING OFF
END
/*** END CREATE TABLES SECTION ***/

/*** BEGIN UPDATE DATABASE SECTION ***/
IF NOT EXISTS(SELECT * FROM sys.columns WHERE Name = N'transRequest' AND Object_ID = Object_ID(N'[dbo].[WppRequest]'))
	ALTER TABLE [dbo].[WppRequest] ADD transRequest VARCHAR(max) NULL

IF NOT EXISTS(SELECT * FROM sys.columns WHERE Name = N'transRequest' AND Object_ID = Object_ID(N'[dbo].[WppOffline]'))
	ALTER TABLE [dbo].[WppOffline] ADD transRequest VARCHAR(max) NULL

IF NOT EXISTS(SELECT * FROM sys.columns WHERE Name = N'transRequest' AND Object_ID = Object_ID(N'[dbo].[WppOfflineDecline]'))
	ALTER TABLE [dbo].[WppOfflineDecline] ADD transRequest VARCHAR(max) NULL

IF NOT EXISTS(SELECT * FROM sys.columns WHERE Name = N'cardData' AND Object_ID = Object_ID(N'[dbo].[WppRequest]'))
	ALTER TABLE [dbo].[WppRequest] ADD cardData VARCHAR(max) NULL

IF NOT EXISTS(SELECT * FROM sys.columns WHERE Name = N'tipAmount' AND Object_ID = Object_ID(N'[dbo].[WppRequest]'))
	ALTER TABLE [dbo].[WppRequest] ADD tipAmount smallmoney NULL

IF NOT EXISTS(SELECT * FROM sys.columns WHERE Name = N'userData' AND Object_ID = Object_ID(N'[dbo].[WppTransaction]'))
	ALTER TABLE [dbo].[WppTransaction] ADD userData VARCHAR(max) NULL

IF NOT EXISTS(SELECT * FROM sys.columns WHERE Name = N'offlineTrans' AND Object_ID = Object_ID(N'[dbo].[WppTransaction]'))
	ALTER TABLE [dbo].[WppTransaction] ADD offlineTrans bit NULL

IF EXISTS(SELECT * FROM sys.columns WHERE Name = N'chipData' AND Object_ID = Object_ID(N'[dbo].[WppTransaction]'))
	ALTER TABLE [dbo].[WppTransaction] alter column chipData VARCHAR(max) NULL

IF NOT EXISTS(SELECT * FROM sys.columns WHERE Name = N'originalChipData' AND Object_ID = Object_ID(N'[dbo].[WppTransaction]'))
	ALTER TABLE [dbo].[WppTransaction] add originalChipData VARCHAR(max) NULL

IF EXISTS(SELECT * FROM sys.columns WHERE Name = N'sigData' AND Object_ID = Object_ID(N'[dbo].[WppTransaction]'))
	ALTER TABLE [dbo].[WppTransaction] alter column sigData VARCHAR(max) NULL

IF NOT EXISTS(SELECT * FROM sys.columns WHERE Name = N'requestType' AND Object_ID = Object_ID(N'[dbo].[WppOfflineDecline]'))
	Alter table[dbo].[WppOfflineDecline] ADD requestType bigint NULL 

IF NOT EXISTS(SELECT * FROM sys.columns WHERE Name = N'requestType' AND Object_ID = Object_ID(N'[dbo].[WppOffline]'))
	Alter table[dbo].[WppOffline] ADD requestType bigint NULL 

IF NOT EXISTS(SELECT * FROM sys.columns WHERE Name = N'tipAmount' AND Object_ID = Object_ID(N'[dbo].[WppRequest]'))
	Alter table[dbo].[WppRequest] ADD tipAmount smallmoney NULL

IF NOT EXISTS(SELECT * FROM sys.columns WHERE Name = N'isInitialRequest' AND Object_ID = Object_ID(N'[dbo].[WppRequest]'))
	Alter table[dbo].[WppRequest] ADD isInitialRequest bit NULL
	
GO	

if not exists (SELECT * FROM sys.tables WHERE name = N'PayAtTable')
Begin	
		
	CREATE TABLE [dbo].[PayAtTable](
		[Id] [bigint] IDENTITY(1,1) NOT NULL,
		[dateUtc] [datetime] NULL,
		[storeId] [varchar](16) NOT NULL,
		[terminalId] [varchar](16) NOT NULL, 
		[tableId] [varchar](max) NOT NULL,
		[numChecks] int NOT NULL,
		[totalAmount] varchar(max) NOT NULL,
		[taxAmount] varchar(max) NULL,
		[clerkId] varchar(99) NOT NULL,
		[checkNumber] varchar(max) NOT NULL,
		[approval] varchar(max) NULL
	PRIMARY KEY CLUSTERED 
	(
		[Id] ASC
	)
	) 
End
GO

IF NOT EXISTS(SELECT * FROM sys.columns WHERE Name = N'posResponse' AND Object_ID = Object_ID(N'[dbo].[WppRequest]'))
	Alter table[dbo].[WppRequest] ADD posResponse varchar(max) NULL
Go

IF NOT EXISTS(SELECT * FROM sys.columns WHERE Name = N'cardData' AND Object_ID = Object_ID(N'[dbo].[WppTransaction]'))
	Alter table[dbo].[WppTransaction] ADD cardData varchar(max) NULL
Go

IF NOT EXISTS(SELECT * FROM sys.columns WHERE Name = N'tor' AND Object_ID = Object_ID(N'[dbo].[WppRequest]'))
	Alter table[dbo].[WppRequest] ADD tor bit NULL
Go

IF NOT EXISTS(SELECT * FROM sys.columns WHERE Name = N'originalChipData' AND Object_ID = Object_ID(N'[dbo].[WppTransaction]'))
	Alter table[dbo].[WppTransaction] ADD originalChipData varchar(max)
Go

Alter table [dbo].[WppOffline] Alter Column requestId [varchar](32) NOT NULL
GO

Alter table [dbo].[WppOfflineDecline] Alter Column requestId [varchar](32) NOT NULL
GO

Alter table [dbo].[WppRequest] Alter Column userData [varchar](99) NULL
GO

Alter table [dbo].[WppRequest] Alter Column merchantReferenceCode varchar(99) NULL
GO

IF NOT EXISTS(SELECT * FROM sys.indexes WHERE Name = N'IX_WppTransaction_requestType')
	CREATE INDEX [IX_WppTransaction_requestType] ON [dbo].[WppTransaction] (requestId);
GO

IF NOT EXISTS(SELECT * FROM sys.indexes WHERE Name = N'IX_WppTransaction_dateUtc')
	CREATE INDEX [IX_WppTransaction_dateUtc] ON [dbo].[WppTransaction] (dateUtc);
GO

IF NOT EXISTS(SELECT * FROM sys.indexes WHERE Name = N'IX_WppRequest_userData')
	CREATE INDEX [IX_WppRequest_userData] ON [dbo].[WppRequest] (userData);
GO

IF NOT EXISTS(SELECT * FROM sys.indexes WHERE Name = N'IX_WppRequest_transactionId')
	CREATE INDEX [IX_WppRequest_transactionId] ON [dbo].[WppRequest] (transactionId);
GO

IF NOT EXISTS(SELECT * FROM sys.indexes WHERE Name = N'IX_WppRequest_dateUtc')
	CREATE INDEX [IX_WppRequest_dateUtc] ON [dbo].[WppRequest] (dateUtc);
GO

IF NOT EXISTS(SELECT * FROM sys.indexes WHERE Name = N'IX_WppRequest_requestId')
	CREATE INDEX [IX_WppRequest_requestId] ON [dbo].[WppRequest] (requestId);
GO

IF NOT EXISTS(SELECT * FROM sys.indexes WHERE Name = N'IX_WppRequest_merchantReferenceCode')
	CREATE INDEX [IX_WppRequest_merchantReferenceCode] ON [dbo].[WppRequest] (merchantReferenceCode);
GO


if not exists (SELECT * FROM sys.tables WHERE name = N'Log')
Begin	
		
	CREATE TABLE [dbo].[Log](
	[id]                    BIGINT        IDENTITY (1, 1) NOT NULL,
	[entryType]             VARCHAR (20)  NULL,
	[startDate]             DATETIME2 (7) NULL,
	[transactionNumber]     BIGINT        NULL,
	[merchantReferenceCode] VARCHAR (50)  NULL,
	[processorTime]         BIGINT        NULL,
	[requestId]             VARCHAR (50)  NULL,
	[finishDate]            DATETIME2 (7) NULL,
	[fccRequest]            VARCHAR (MAX) NULL,
	[fccResponse]           VARCHAR (MAX) NULL,
	[processorRequest]      VARCHAR (MAX) NULL,
	[processorResponse]     VARCHAR (MAX) NULL,
	[requestType]           VARCHAR (100) NULL,
	[responseCode]          VARCHAR (20)  NULL,
	[serverName]            VARCHAR (100) NULL,
	[errorMessage]          VARCHAR (MAX) NULL
	PRIMARY KEY CLUSTERED 
	(
		[Id] ASC
	) 
	) 
End
GO

IF NOT EXISTS(SELECT * FROM sys.indexes WHERE Name = N'IX_Log_merchantReferenceCode')
	CREATE INDEX [IX_Log_merchantReferenceCode] ON [dbo].[Log] (merchantReferenceCode);
GO

IF NOT EXISTS(SELECT * FROM sys.indexes WHERE Name = N'IX_Log_requestId')
	CREATE INDEX [IX_Log_requestId] ON [dbo].[Log] (requestId);
GO

IF NOT EXISTS(SELECT * FROM sys.indexes WHERE Name = N'IX_Log_startDate')
	CREATE INDEX [IX_Log_startDate] ON [dbo].[Log] (startDate);
GO

IF NOT EXISTS(SELECT * FROM sys.indexes WHERE Name = N'IX_Log_transactionNumber')
	CREATE INDEX [IX_Log_transactionNumber] ON [dbo].[Log] (transactionNumber);
GO



IF NOT EXISTS (SELECT * FROM sys.indexes WHERE object_id = OBJECT_ID(N'[dbo].[Log]') AND name = N'idx_nc_Log_ResponseCode')
CREATE NONCLUSTERED INDEX [idx_nc_Log_ResponseCode] ON [dbo].[Log]
(
	[StartDate] ASC,
	[responseCode] ASC
)
GO


IF NOT EXISTS (SELECT * FROM sys.indexes WHERE object_id = OBJECT_ID(N'[dbo].[Log]') AND name = N'idx_nc_Log_RequestType')
CREATE NONCLUSTERED INDEX [idx_nc_Log_RequestType] ON [dbo].[Log]
(
	[StartDate] ASC,
	[requestType] ASC
)
GO

IF NOT EXISTS (SELECT * FROM sys.indexes WHERE object_id = OBJECT_ID(N'[dbo].[Log]') AND name = N'idx_nc_Log_ServerName')
CREATE NONCLUSTERED INDEX [idx_nc_Log_ServerName] ON [dbo].[Log]
(
	[StartDate] ASC,
	[serverName] ASC,
	[responseCode] ASC
)
GO


IF EXISTS(SELECT * FROM sys.columns WHERE Name = N'tipAmount' AND Object_ID = Object_ID(N'[dbo].[WppOffline]'))
alter table WppOffline alter column [tipAmount][money]

IF EXISTS(SELECT * FROM sys.columns WHERE Name = N'approvedAmount' AND Object_ID = Object_ID(N'[dbo].[WppRequest]'))
alter table WppRequest alter column [approvedAmount][money]

IF EXISTS(SELECT * FROM sys.columns WHERE Name = N'tipAmount' AND Object_ID = Object_ID(N'[dbo].[WppRequest]'))
alter table WppRequest alter column [tipAmount][money]

GO

if not exists (SELECT * FROM sys.tables WHERE name = N'TransactionResultTracking')
Begin	
		
	CREATE TABLE [dbo].[TransactionResultTracking](
		[Id] [bigint] IDENTITY(1,1) NOT NULL,
		[dateUtc] datetime NULL,
		[storeId] varchar(64) NOT NULL,
		[rvc] int NOT NULL,
		[trantime] int NOT NULL,
		[trandate] int NOT NULL,
		[hash] int NOT NULL,
		[result] varchar(max) NOT NULL)
	CREATE UNIQUE NONCLUSTERED INDEX IX_TransactionResultTracking ON dbo.TransactionResultTracking
	(
	storeId,
	rvc,
	trantime,
	trandate,
	hash
	)

	CREATE NONCLUSTERED INDEX DATEUTC_IX ON dbo.TransactionResultTracking
	(
	dateUtc
	)
End
GO


if not exists (SELECT * FROM sys.tables WHERE name = N'MicrosTransaction')
Begin	
		
	CREATE TABLE [dbo].[MicrosTransaction](
		[Id] [bigint] IDENTITY(1,1) NOT NULL,
		[dateUtc] datetime NULL,
		[storeId] varchar(64) NOT NULL,
		[rvc] varchar(10) NOT NULL,
		[authcode] varchar(10) NOT NULL,
		[authamount] varchar(15) NOT NULL,
		[checknum] varchar(10) NOT NULL,
		[jsToken] varchar(20) NOT NULL,
		[expDate] varchar(4) NOT NULL,
		[requestID] varchar(64) NOT NULL,
		[last4] varchar(4) NOT NULL,
		[floorlimit] varchar(15) NOT NULL,
		[BatchedStatus] tinyint NOT NULL default 0)
	CREATE UNIQUE NONCLUSTERED INDEX IX_MicrosTransactionRequestID ON dbo.MicrosTransaction
	(
	storeId,
	authcode,
	authamount,
	checknum,
	last4,
	jsToken
	)

	CREATE UNIQUE NONCLUSTERED INDEX IX_MicrosTransaction ON dbo.MicrosTransaction
	(
	requestID
	)
End

Go

DELETE FROM dbo.wpptransaction WHERE [id] IN (SELECT [id] FROM dbo.wpptransaction GROUP BY [id] HAVING COUNT(*) > 1)
GO

IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'PK_wpptransaction') AND type in (N'PK'))
BEGIN
	ALTER TABLE dbo.wpptransaction ADD CONSTRAINT [PK_wpptransaction] PRIMARY KEY (id);
END
GO

DELETE FROM dbo.wppRequest WHERE [id] IN (SELECT [id] FROM dbo.wppRequest GROUP BY [id] HAVING COUNT(*) > 1)
GO
	
IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'PK_wppRequest') AND type in (N'PK'))
BEGIN
	ALTER TABLE dbo.wppRequest ADD CONSTRAINT [PK_wppRequest] PRIMARY KEY (id);
END
GO


/*Temporary fix to remove logs that could contain unenrypted data.  This function should be removed in the next version*/
if not exists (SELECT * FROM sys.tables WHERE name = N'Log')
Begin
	Update Log set FCCRequest = NULL,processorRequest = NULL
End

GO
if not exists (SELECT * FROM sys.tables WHERE name = N'Opi')
Begin	
	CREATE TABLE [dbo].[Opi](
		[id] [bigint] IDENTITY(1,1) NOT NULL,
		[OriginalId] [bigint] NULL,
		[SequenceNo] [bigint] NULL,
		[folioNumber] [varchar](50) NULL,
		[dateUtc] [datetime] NOT NULL CONSTRAINT [DF_Opi_dateUtc]  DEFAULT (getutcdate()),
		[freewayRequestId] [varchar](32) NULL,
		[allowIncrAuth] [bit] NOT NULL,
		[amount] [money] NOT NULL CONSTRAINT [DF_Opi_amount]  DEFAULT (($0.0000)),
		[authorizedAmount] [money] NOT NULL CONSTRAINT [DF_Opi_authorizedAmount]  DEFAULT (($0.0000)),
		[capturedAmount] [money] NULL,
		[opiTransType] varchar(20) NULL,
		 CONSTRAINT [PK_Opi] PRIMARY KEY CLUSTERED 
		(
			[id] ASC
		)
	) 

	CREATE NONCLUSTERED INDEX IX_Opi ON dbo.Opi
	(
	OriginalId,
	id
	)
END

GO

IF NOT EXISTS(SELECT * FROM sys.columns WHERE Name = N'opiTransType' AND Object_ID = Object_ID(N'[dbo].[Opi]'))
	ALTER TABLE dbo.Opi ADD opiTransType varchar(20) NULL
GO

IF NOT EXISTS(select * from sys.tables WHERE name = N'PosiTouchRequest')
BEGIN
	CREATE TABLE [dbo].[PosiTouchRequest](
	[id]        BIGINT    IDENTITY (1, 1) NOT NULL,
	[requestId] VARCHAR (32)           NULL,
	[posiTouchId] VARCHAR (16) NOT NULL ,
	[requestType] INT DEFAULT '0',
	[requestDate] DATETIME2 (7) NULL,
	[isDebit] BIT DEFAULT '0',
	Primary Key Clustered (id asc))

	CREATE UNIQUE NONCLUSTERED INDEX IX_PosiTouchRequest ON dbo.PosiTouchRequest
		(
		posiTouchId,
		requestType
		)
	END

GO


IF NOT EXISTS(SELECT * FROM sys.columns WHERE Name = N'opiCheckInDate' AND Object_ID = Object_ID(N'[dbo].[Opi]'))
ALTER TABLE dbo.Opi ADD
	opiCheckInDate varchar(8) NULL,
	token varchar(50) NULL
GO

IF NOT EXISTS(SELECT * FROM sys.columns WHERE Name = N'posResponse' AND Object_ID = Object_ID(N'[dbo].[Opi]'))
ALTER TABLE dbo.Opi ADD
	posResponse varchar(MAX) NULL
GO

/*** END UPDATE DATABASE SECTION ***/

/*** BEGIN CREATE PROCS SECTION ***/

/****** Object:  StoredProcedure [dbo].[AddRequestAndGetByRequestId]    Script Date: 11/30/2015 9:05:07 AM ******/
if exists(select * from sys.procedures where name = N'AddRequestAndGetByRequestId')
drop procedure [dbo].[AddRequestAndGetByRequestId]
GO
	CREATE Procedure [dbo].[AddRequestAndGetByRequestId]
		@requestId varchar(max),
		@merchantReferenceCode varchar(max),
		@newRequestId bigint = null output
	As
	Begin
		Declare @transactionId int
		Select @transactionId=Id from WppTransaction where requestId=@requestId
		Insert into WppRequest (transactionId, merchantReferenceCode) values (@transactionId, @merchantReferenceCode)
		Select @newRequestId = scope_identity();
		Select * from WppTransaction where Id=@transactionId
	End
GO


/****** Object:  StoredProcedure [dbo].[AddRequestAndGetByTransactionId]    Script Date: 11/30/2015 9:05:07 AM ******/
if exists(select * from sys.procedures where name = N'AddRequestAndGetByTransactionId')
drop procedure 	[dbo].[AddRequestAndGetByTransactionId]
GO
	CREATE PROCEDURE [dbo].[AddRequestAndGetByTransactionId]
		@transactionId bigint,
		@merchantReferenceCode varchar(max),
		@requestId bigint = null output
	AS
	Begin
		insert into WppRequest (transactionId, merchantReferenceCode) values (@transactionId, @merchantReferenceCode)
		Select @requestId = scope_identity();
		SELECT * from WppTransaction where Id=@transactionId
	End
GO

/****** Object:  StoredProcedure [dbo].[GetMatchingUserData]    Script Date: 11/30/2015 9:05:07 AM ******/
if exists(select * from sys.procedures where name = N'GetMatchingUserData')
	drop procedure 	[dbo].[GetMatchingUserData]
GO

CREATE PROCEDURE [dbo].[GetMatchingUserData]
	@userData varchar(max)
AS
	Select * from WppRequest where userData like @userData and errorCode = '100' or errorCode = '3021'
GO

	
/****** Object:  StoredProcedure [dbo].[Decline_Process]    Script Date: 11/30/2015 9:05:07 AM ******/
if exists(select * from sys.procedures where name = N'Decline_Process')
drop procedure [dbo].[Decline_Process]
Go
	
	CREATE PROCEDURE [dbo].[Decline_Process]
	AS
		SELECT * from WppOfflineDecline

GO
	
	/****** Object:  StoredProcedure [dbo].[Decline_Prune]    Script Date: 11/30/2015 9:05:07 AM ******/
if exists(select * from sys.procedures where name = N'Decline_Prune')
drop procedure [dbo].[Decline_Prune]
Go	
	CREATE PROCEDURE [dbo].[Decline_Prune]
		@id bigint
	AS
		Delete from WppOfflineDecline where Id=@id
GO

	
	/****** Object:  StoredProcedure [dbo].[GetByTransactionId]    Script Date: 11/30/2015 9:05:07 AM ******/
if exists(select * from sys.procedures where name = N'GetByTransactionId')
drop procedure 	[dbo].[GetByTransactionId]
GO
	CREATE PROCEDURE [dbo].[GetByTransactionId]
		@id bigint
	AS
		SELECT * from WppTransaction where Id=@id
GO

	
	/****** Object:  StoredProcedure [dbo].[GetRequestInfo]    Script Date: 11/30/2015 9:05:07 AM ******/
if exists(select * from sys.procedures where name = N'GetRequestInfo')
drop procedure 	[dbo].[GetRequestInfo]
GO
	
	CREATE PROCEDURE [dbo].[GetRequestInfo]
		@requestId varchar(32) = null,
		@transactionId bigint = null,
		@merchantReferenceCode varchar(max) = null
	AS
		If @transactionId <> null
			SELECT * from WppRequest where transactionId=@transactionId
		Else If @requestId <> null
			SELECT * from WppRequest where requestId=@requestId
		Else
			SELECT * from WppRequest where merchantReferenceCode=@merchantReferenceCode
GO

	
	/****** Object:  StoredProcedure [dbo].[GetRequestInfoByMerchantReferenceCode]    Script Date: 11/30/2015 9:05:07 AM ******/
if exists(select * from sys.procedures where name = N'GetRequestInfoByMerchantReferenceCode')
drop procedure 	[dbo].[GetRequestInfoByMerchantReferenceCode]
GO
	
	CREATE PROCEDURE [dbo].[GetRequestInfoByMerchantReferenceCode]
		@merchantReferenceCode varchar(max)
	AS
		SELECT * from WppRequest inner join WppTransaction on WppTransaction.requestId = WppRequest.requestId 
		where WppRequest.merchantReferenceCode like @merchantReferenceCode 
GO

	
	/****** Object:  StoredProcedure [dbo].[GetRequestInfoByRequestId]    Script Date: 11/30/2015 9:05:07 AM ******/
if exists(select * from sys.procedures where name = N'GetRequestInfoByRequestId')
drop procedure 	[dbo].[GetRequestInfoByRequestId]
GO
	
	CREATE PROCEDURE [dbo].[GetRequestInfoByRequestId]
		@requestId varchar(max)
	AS
		SELECT * from WppRequest where requestId=@requestId
GO

	/****** Object:  StoredProcedure [dbo].[GetRequestInfoByWppRequestId]    Script Date: 11/30/2015 9:05:07 AM ******/
if exists(select * from sys.procedures where name = N'GetRequestInfoByWppRequestId')
drop procedure 	[dbo].[GetRequestInfoByWppRequestId]
GO
	
	CREATE PROCEDURE [dbo].[GetRequestInfoByWppRequestId]
		@id bigint
	AS
		SELECT * from WppRequest where Id=@id
GO

	/****** Object:  StoredProcedure [dbo].[GetRequestInfoByAtlasRequestId]    Script Date: 11/30/2015 9:05:07 AM ******/
if exists(select * from sys.procedures where name = N'GetRequestInfoByAtlasRequestId')
drop procedure 	[dbo].[GetRequestInfoByAtlasRequestId]
GO
	
	CREATE PROCEDURE [dbo].[GetRequestInfoByAtlasRequestId]
		@id bigint
	AS
		SELECT * from WppRequest where id=@id
GO

	
	/****** Object:  StoredProcedure [dbo].[GetRequestInfoByTransactionId]    Script Date: 11/30/2015 9:05:07 AM ******/
if exists(select * from sys.procedures where name = N'GetRequestInfoByTransactionId')
drop procedure 	[dbo].[GetRequestInfoByTransactionId]
GO
	CREATE PROCEDURE [dbo].[GetRequestInfoByTransactionId]
		@transactionId bigint
	AS
		SELECT * from WppRequest where transactionId=@transactionId

GO
	
	/****** Object:  StoredProcedure [dbo].[GetTransactionInfoByRequestId]    Script Date: 11/30/2015 9:05:07 AM ******/
if exists(select * from sys.procedures where name = N'GetTransactionInfoByRequestId')
drop procedure [dbo].[GetTransactionInfoByRequestId]
GO
	
	CREATE PROCEDURE [dbo].[GetTransactionInfoByRequestId]
		@requestId varchar(32)
	AS
		SELECT * from WppTransaction, WppRequest
		where WppRequest.requestId=@requestId and WppTransaction.Id=WppRequest.transactionId
GO

	
	/****** Object:  StoredProcedure [dbo].[Offline_Add]    Script Date: 11/30/2015 9:05:07 AM ******/
if exists(select * from sys.procedures where name = N'Offline_Add')
drop procedure 	[dbo].[Offline_Add]
GO
	CREATE PROCEDURE [dbo].[Offline_Add]
		@cardData varchar(max) = null,
		@transRequest varchar(max) = null,
		@errorCode int = 100,
		@transactionId bigint,
		@requestId varchar(32),
		@requestType bigint,
		@posResponse varchar(max),
		@id bigint out
	AS
		update WppRequest set posResponse=@posResponse where requestId=@requestId;
		insert into WppOffline(dateUtc, cardData, transRequest, errorCode, requestId, transactionId, requestType) 
		values (GETUTCDATE(), @cardData, @transRequest, @errorCode, @requestId, @transactionId, @requestType);
		select @id = scope_identity()
GO

	
	/****** Object:  StoredProcedure [dbo].[Offline_MoveToDecline]    Script Date: 11/30/2015 9:05:07 AM ******/

if exists(select * from sys.procedures where name = N'Offline_MoveToDecline')
drop procedure [dbo].[Offline_MoveToDecline]
GO
	
	Create Procedure [dbo].[Offline_MoveToDecline]
		@id bigint,
		@posResponse varchar(max)
	AS
		Insert WppOfflineDecline (cardData, transRequest, dateUtc, transactionId, requestId, errorCode, approvalCode, requestType) 
		Select cardData, transRequest, dateUtc, transactionId, requestId, errorCode, approvalCode, requestType from WppOffline where Id=@id;
		Update WppRequest set posResponse=@posResponse where id=@id
		Delete from WppOffline where Id=@id

GO
	
	/****** Object:  StoredProcedure [dbo].[Offline_Process]    Script Date: 11/30/2015 9:05:07 AM ******/
	
if exists(select * from sys.procedures where name = N'Offline_Process')
drop procedure [dbo].[Offline_Process]
GO
	CREATE PROCEDURE [dbo].[Offline_Process]
	AS
		SELECT * from WppOffline
GO

	
	/****** Object:  StoredProcedure [dbo].[Offline_Update]    Script Date: 11/30/2015 9:05:07 AM ******/
if exists(select * from sys.procedures where name = N'Offline_Update')
drop procedure [dbo].[Offline_Update]
GO
	
	CREATE PROCEDURE [dbo].[Offline_Update]
		@offlineId bigint,
		@wppRequestId bigint,
		@freewayRequestId varchar(32) = null,
		@transactionId bigint,
		@errorCode int = null,
		@approvalCode varchar(6) = null,
		@approvedAmount money = null,
		@posResponse varchar(max)
	AS
		Delete from WppOffline where Id=@offlineId;
		Update WppRequest 
		set cardData=null, requestId=@freewayRequestId, approvalCode=@approvalCode, approvedAmount=@approvedAmount, errorCode=@errorCode, posResponse=@posResponse
		where Id=@wppRequestId;
		Update WppTransaction set cardData=null, requestId=@freewayRequestId where Id=@transactionId;
GO
	
	/****** Object:  StoredProcedure [dbo].[PruneOldEntries]    Script Date: 11/30/2015 9:05:07 AM ******/
if exists(select * from sys.procedures where name = N'PruneOldEntries')
drop procedure 	[dbo].[PruneOldEntries]
GO
	CREATE PROCEDURE [dbo].[PruneOldEntries]
		@pruneDate date
	AS
		delete from WppTransaction where dateUtc < @pruneDate
		delete from WppRequest where dateUtc < @pruneDate
		delete from WppOffline where dateUtc < @pruneDate
		delete from TransactionResultTracking where dateUtc < @pruneDate
		delete from MicrosTransaction where dateUtc < @pruneDate
		delete from PosiTouchRequest where requestDate < @pruneDate
GO
	
	/****** Object:  StoredProcedure [dbo].[Transaction_Add]    Script Date: 11/30/2015 9:05:07 AM ******/
if exists(select * from sys.procedures where name = N'Transaction_Add')
drop procedure	[dbo].[Transaction_Add] 
GO
	CREATE proc [dbo].[Transaction_Add] 
	(
		@folioDate datetime = null,
		@folioNumber varchar(50) = null,
		@useDcc bit = 0,
		@allowIncrAuth bit = 1,
		@merchantReferenceCode varchar(max) = null,
		@storeId varchar(MAX) = null,
		@terminalId varchar(MAX) = null,
		@clientEnvironment varchar(MAX) = null,
		@approvalCode varchar(max) = null,
		@userData varchar(max) = null,
		@isInitialRequest bit = null,
		@originalChipData varchar(max) = null,
		@transactionId bigint = null output,
		@requestId bigint = null output
	)
	As
		insert into WppTransaction (folioDate, folioNumber, useDcc, allowIncrAuth, storeId, terminalId, clientEnvironment, originalChipData)
			values (@folioDate, @folioNumber, @useDcc, @allowIncrAuth, @storeId, @terminalId, @clientEnvironment, @originalChipData)
		Select @transactionId = scope_identity();

		insert into WppRequest (transactionId, merchantReferenceCode, approvalCode, userData, isInitialRequest) 
			values (@transactionId, @merchantReferenceCode, @approvalCode, @userData, @isInitialRequest)
		Select @requestId = scope_identity();

GO
	
	/****** Object:  StoredProcedure [dbo].[Transaction_GetById]    Script Date: 11/30/2015 9:05:07 AM ******/
if exists(select * from sys.procedures where name = N'Transaction_GetById')
drop procedure 	[dbo].[Transaction_GetById]
GO
	CREATE Procedure [dbo].[Transaction_GetById] (@id bigint)
	As
	Select * from WppTransaction where Id = @id
GO

	
	/****** Object:  StoredProcedure [dbo].[Update]    Script Date: 11/30/2015 9:05:07 AM ******/
	
if exists(select * from sys.procedures where name = N'Update')
drop procedure [dbo].[Update] 
GO


CREATE proc [dbo].[Update]
(
	@id bigint,
	@initialUpdate bit = 0,
	@requestId varchar(max) = null,
	@merchantReferenceCode varchar(max) = null,
	@approvalCode varchar(6) = null,
	@approvedAmount money = null,
	@errorCode int = null,
	@transRequest varchar(max) = null,
	@cardData varchar(max) = null,
	@offlineTrans bit = 0,
	@chipData varchar(max) = null,
	@originalChipData varchar(max) = null,
	@sigData varchar(max) = null,
	@useDcc bit = 0,
	@allowIncrAuth bit = null,
	@emvTagData varchar(max) = NULL,
	@token varchar(max) = null,
	@expiryDate varchar(max) = null,
	@maskedCardNumber varchar(max) = null,
	@cardType varchar(MAX) = null,
	@tipAmount money = NULL,
	@tor bit output
)
AS
	SET NOCOUNT ON;
	SET DEADLOCK_PRIORITY LOW;
	SET XACT_ABORT ON;

	BEGIN TRANSACTION;

	UPDATE WppOffline
	Set approvalCode=@approvalCode Where requestId=@requestId

	UPDATE WppRequest
	SET requestId=@requestId, 
		approvalCode=@approvalCode, 
		approvedAmount=@approvedAmount, 
		errorCode=@errorCode, 
		transRequest=@transRequest,
		cardData=@cardData,
		tipAmount=@tipAmount
	WHERE transactionId = @id and merchantReferenceCode=@merchantReferenceCode
	SELECT tor from WppRequest WHERE transactionId = @id and merchantReferenceCode=@merchantReferenceCode

	If @initialUpdate = 0
	BEGIN
		UPDATE WppTransaction
		SET requestId=@requestId,
			token=@token,
			expiryDate=ISNULL(@expiryDate,expiryDate),
			maskedCardNumber=ISNULL(@maskedCardNumber,maskedCardNumber),
			cardType=ISNULL(@cardType,cardType),
			offlineTrans=@offlineTrans
		WHERE Id=@id
	END
	ELSE
	BEGIN
		UPDATE WppTransaction
		SET requestId=@requestId,
			expiryDate=ISNULL(@expiryDate,expiryDate),
			maskedCardNumber=ISNULL(@maskedCardNumber,maskedCardNumber),
			cardType=ISNULL(@cardType,cardType),
			chipData=@chipData,
			originalChipData=@originalChipData,
			sigData=@sigData,
			useDcc=@useDcc,
			emvTagData=@emvTagData,
			offlineTrans=@offlineTrans,
			cardData=@cardData
		WHERE id=@id
	END
	
	COMMIT TRANSACTION;
GO

/****** Object:  StoredProcedure [dbo].[Followup]    Script Date: 1/12/2016 ******/
if exists(select * from sys.procedures where name = N'Followup')
drop procedure [dbo].[Followup] 
GO
Create Procedure [dbo].[Followup]
(
	@sigData varchar(max),
	@chipData varchar(max),
	@requestId varchar(32)
)
as
	Update trn set sigData=@sigData, chipData=@chipData from WppTransaction trn 
	INNER JOIN WppRequest req ON trn.id=req.transactionId WHERE req.requestId=@requestId
go

/****** Object:  StoredProcedure [dbo].[Pat_Add]    Script Date: 1/12/2016 ******/
	
if exists(select * from sys.procedures where name = N'Pat_Add')
drop procedure [dbo].[Pat_Add] 
GO
Create Procedure [dbo].[Pat_Add]
(
	@storeId varchar(16) = null,
	@terminalId varchar(16) = null,
	@tableId varchar(max) = null,
	@numChecks int = null,
	@totalAmount varchar(max) = null,
	@taxAmount varchar(max) = null,
	@clerkId varchar(99) = null,
	@checkNumber varchar(99) = null
)
as
	insert into PayAtTable (dateUtc, storeId, terminalId, tableId, numChecks, totalAmount, taxAmount, clerkId, checkNumber)
	values (GETUTCDATE(), @storeId, @terminalId, @tableId, @numChecks, @totalAmount, @taxAmount, @clerkId, @checkNumber)
go

/****** Object:  StoredProcedure [dbo].[Pat_Inquire]    Script Date: 1/12/2016 ******/
	
if exists(select * from sys.procedures where name = N'Pat_Inquire')
drop procedure [dbo].[Pat_Inquire] 
GO
Create Procedure [dbo].[Pat_Inquire]
(
	@userData varchar(99)
)
as
	select WppRequest.*, WppTransaction.maskedCardNumber, WppTransaction.expiryDate 
	from WppTransaction inner join WppRequest on WppRequest.requestId=WppTransaction.requestId and WppRequest.userData=@userData
go

if exists(select * from sys.procedures where name = N'Pat_Update')
drop procedure [dbo].[Pat_Update] 
GO
Create Procedure [dbo].[Pat_Update]
(
	@userData varchar(99),
	@requestId varchar(32),
	@maskedCardNumber varchar(20),
	@expiryDate char(4)

)
as
	Update WppRequest set userData=@userData where requestId=@requestId
	Update WppTransaction set maskedCardNumber=@maskedCardNumber, expiryDate=@expiryDate where requestId=@requestId
go

if exists(select * from sys.procedures where name = N'TruncateDatabase')
drop procedure [dbo].[TruncateDatabase]
GO
Create Procedure [dbo].[TruncateDatabase]
as
	truncate table WppTransaction
	truncate table WppRequest
	truncate table WppOffline
	truncate table WppOfflineDecline
	truncate table PayAtTable
	truncate table TransactionResultTracking
	truncate table MicrosTransaction
	truncate table PosiTouchRequest
	truncate table Log
go

if exists(select * from sys.procedures where name = N'GetByMerchantReferenceCodeAndSetTorBit')
drop procedure [dbo].[GetByMerchantReferenceCodeAndSetTorBit]
GO
Create Procedure [dbo].[GetByMerchantReferenceCodeAndSetTorBit]
(
	@merchantReferenceCode varchar(max)
)
as
	SELECT * from WppRequest inner join WppTransaction on WppTransaction.requestId = WppRequest.requestId 
	where WppRequest.merchantReferenceCode like @merchantReferenceCode 
	Update WppRequest set tor = 1 where WppRequest.merchantReferenceCode like @merchantReferenceCode 
go

if exists(select * from sys.procedures where name = N'GetOfflineTransactionByID')
drop procedure [dbo].[GetOfflineTransactionByID]
GO
Create Procedure [dbo].[GetOfflineTransactionByID]
(
	@requestID varchar(max)
)
as
	SELECT * from Wppoffline where requestID = @requestID
Go

if exists (select * from sys.procedures where name = N'Log_Add')
drop procedure [dbo].[Log_Add]
GO

CREATE PROCEDURE [dbo].[Log_Add] (
	@startDate datetime2 = NULL,
	@entryType varchar(20) = NULL,
	@transactionNumber bigint = NULL,
	@merchantReferenceCode varchar(50) = NULL,
	@processorTime bigint = NULL,
	@requestId varchar(50) = NULL,
	@finishDate datetime2 = NULL,
	@fccRequest varchar(max) = NULL,
	@fccResponse varchar(max) = NULL,
	@processorRequest varchar(max) = NULL,
	@processorResponse varchar(max) = NULL,
	@requestType varchar(100) = NULL,
	@responseCode varchar(20) = NULL,
	@serverName varchar(100) = NULL,
	@errorMessage varchar(max) = NULL
) AS
BEGIN
	insert into [dbo].[Log](startDate, 
	entryType,
	transactionNumber,
	merchantReferenceCode,
	processorTime,
	requestId,
	finishDate,
	fccRequest,
	fccResponse,
	processorRequest,
	processorResponse,
	requestType,
	responseCode,
	serverName,
	errorMessage
	)

	values (@startDate,
	@entryType,
	@transactionNumber,
	@merchantReferenceCode,
	@processorTime,
	@requestId,
	@finishDate,
	@fccRequest,
	@fccResponse,
	@processorRequest,
	@processorResponse,
	@requestType,
	@responseCode,
	@serverName,
	@errorMessage
	)
END
GO

if exists (select * from sys.procedures where name = N'Add_TransactionResultTracking')
drop procedure [dbo].[Add_TransactionResultTracking]
GO
	CREATE PROCEDURE [dbo].[Add_TransactionResultTracking]
		@storeID varchar(64),
		@rvc int,
		@trantime int,
		@trandate int,
		@hash int,
		@result varchar(max)
	AS
		insert into TransactionResultTracking(dateUtc, storeId, rvc, trantime, trandate, hash, result) 
		values (GETUTCDATE(), @storeID, @rvc, @trantime, @trandate, @hash, @result);
GO

if exists (select * from sys.procedures where name = N'Get_TransactionResultTracking')
drop procedure [dbo].[Get_TransactionResultTracking]
GO

GO
	CREATE PROCEDURE [dbo].[Get_TransactionResultTracking]
		@storeID varchar(64),
		@rvc int,
		@trantime int,
		@trandate int,
		@hash int
	AS
		select * from TransactionResultTracking where @storeID = storeID AND @trantime = trantime AND @trandate = trandate AND @hash = hash;
GO

if exists (select * from sys.procedures where name = N'Add_MicrosTransaction')
drop procedure [dbo].[Add_MicrosTransaction]
GO

CREATE PROCEDURE [dbo].[Add_MicrosTransaction]
	@storeID varchar(64),
	@rvc varchar(10),
	@authcode varchar(10),
	@authamount varchar(15),
	@checknum varchar(10),
	@jsToken varchar(20),
	@Last4 varchar(4),
	@expDate varchar(4),
	@requestID varchar(64),
	@floorLimit varchar(15)
	As
	insert into MicrosTransaction(dateUtc, storeId, rvc, authcode, authamount, checknum, jsToken, last4, expDate, requestID, floorlimit)
	values (GETUTCDATE(), @storeID, @rvc, @authcode, @authamount, @checknum, @jsToken, @Last4, @expDate, @requestID, @floorLimit);
GO

if exists (select * from sys.procedures where name = N'Get_MicrosTransaction')
	drop procedure  [dbo].[Get_MicrosTransaction]
GO

CREATE PROCEDURE [dbo].[Get_MicrosTransaction]
	@storeID varchar(64),
	@authcode varchar(10),
	@authamount varchar(15),
	@checknum varchar(10),
	@Last4 varchar(4),
	@jstoken varchar(20)
	AS
	select * from MicrosTransaction where storeId=@storeID AND authcode=@authcode AND authamount=@authamount AND checknum=@checknum AND (last4 = @Last4 OR jsToken = @jstoken) ORDER BY Id DESC;
GO

if exists (select * from sys.procedures where name = N'Batched_MicrosTransaction')
	drop procedure  [dbo].[Batched_MicrosTransaction]
GO

CREATE PROCEDURE [dbo].[Batched_MicrosTransaction]
	@requestID varchar(64),
	@batched tinyint
	AS
	UPDATE MicrosTransaction
		SET BatchedStatus=@batched
		WHERE requestID=@requestID
GO

if exists (select * from sys.procedures where name = N'Get_MicrosTransactionByRequestID')
	drop procedure  [dbo].[Get_MicrosTransactionByRequestID]
GO

CREATE PROCEDURE [dbo].[Get_MicrosTransactionByRequestID]
	@requestID varchar(64)
	AS
	select * from MicrosTransaction where @requestID=requestID;
GO

if exists (select * from sys.procedures where name = N'Get_MicrosTransactionJSTokenStoreIDCheck')
	drop procedure  [dbo].[Get_MicrosTransactionJSTokenStoreIDCheck]
GO

CREATE PROCEDURE [dbo].[Get_MicrosTransactionJSTokenStoreIDCheck]
	@storeID varchar(64),
	@checknum varchar(10),
	@jstoken varchar(20)
	AS
	select * from MicrosTransaction where storeId=@storeID AND checknum=@checknum AND jsToken = @jstoken ORDER BY Id DESC;
GO

if exists (select * from sys.procedures where name = N'Opi_Add')
	drop procedure  [dbo].[Opi_Add]
GO

CREATE PROCEDURE [dbo].[Opi_Add]
(
	@OriginalId BIGINT,
	@SequenceNo BIGINT = NULL,
	@folioNumber VARCHAR(50) = NULL,
	@dateUtc DATETIME = NULL,
	@freewayRequestId VARCHAR(32) = NULL,
	@allowIncrAuth BIT = NULL,
	@amount MONEY = 0.00,
	@authorizedAmount MONEY = 0.00,
	@capturedAmount MONEY = NULL,
	@opiTransType VARCHAR(20) = NULL,
	@opiCheckInDate VARCHAR(8) = NULL,
	@token VARCHAR(50) = NULL,
	@posResponse VARCHAR(MAX) = NULL,
	@Id BIGINT OUT
)
AS
BEGIN
	INSERT INTO [dbo].[Opi]
			   ([OriginalId]
			   ,[SequenceNo]
			   ,[folioNumber]
			   ,[dateUtc]
			   ,[freewayRequestId]
			   ,[allowIncrAuth]
			   ,[amount]
			   ,[authorizedAmount]
			   ,[capturedAmount]
			   ,[opiTransType]
			   ,[opiCheckInDate]
			   ,[token]
			   ,[posResponse])
		 VALUES
			   (@OriginalId
			   ,@SequenceNo
			   ,@folioNumber
			   ,@dateUtc
			   ,@freewayRequestId
			   ,@allowIncrAuth
			   ,@amount
			   ,@authorizedAmount
			   ,@capturedAmount
			   ,@opiTransType
			   ,@opiCheckInDate
			   ,@token
			   ,@posResponse)

	SELECT @Id = SCOPE_IDENTITY()

	IF(@OriginalId = 0)
	BEGIN
		UPDATE [dbo].[Opi] 
		SET [OriginalId] = @Id
		WHERE [Id] = @Id
	END
END
GO

if exists (select * from sys.procedures where name = N'Opi_GetLastById')
	drop procedure  [dbo].[Opi_GetLastById]
GO


if exists (select * from sys.procedures where name = N'Opi_GetLastNonCaptureById')
	drop procedure  [dbo].[Opi_GetLastNonCaptureById]
GO

if exists(select * from sys.procedures where name = N'PosiTouch_AddRequest')
drop procedure [dbo].[PosiTouch_AddRequest]
GO

CREATE Procedure [dbo].[PosiTouch_AddRequest]
		@requestId varchar(33),
		@posiTouchId varchar(17),
		@requestType int,
		@isDebit bit
	As
	Begin
		Insert into PosiTouchRequest (requestId, requestDate, posiTouchID, requestType, isDebit) values (@requestId, GETUTCDATE(), @posiTouchId, @requestType, @isDebit)
	End
go
	
if exists(select * from sys.procedures where name = N'Positouch_UpdateRequest')
drop procedure [dbo].[Positouch_UpdateRequest]
GO

CREATE Procedure [dbo].[Positouch_UpdateRequest]
		@requestId varchar(32),
		@posiTouchId varchar(17),
		@requestType int
	As
	Begin
		update PosiTouchRequest set requestId=@requestId where posiTouchId=@posiTouchId AND requestType=@requestType
	End
GO

if exists(select * from sys.procedures where name = N'PosiTouch_GetRequest')
drop procedure [dbo].[PosiTouch_GetRequest]
GO

CREATE Procedure [dbo].[PosiTouch_GetRequest]
		@posiTouchId varchar(17),
		@requestType int
	As
	Begin
		select * from PosiTouchRequest where posiTouchId=@posiTouchId AND requestType=@requestType
	End
GO


if exists (select * from sys.procedures where name = N'Opi_GetLastByOriginalId')
	drop procedure  [dbo].[Opi_GetLastByOriginalId]
GO

CREATE PROCEDURE [dbo].[Opi_GetLastByOriginalId]
(
	@OriginalId BIGINT
)
AS
SELECT [Opi].[Id]
	  ,[Opi].[OriginalId]
	  ,[SequenceNo]
	  ,[folioNumber]
	  ,[dateUtc]
	  ,[freewayRequestId]
	  ,[allowIncrAuth]
	  ,[amount]
	  ,[authorizedAmount]
	  ,[capturedAmount]
	  ,[opiTransType]
	  ,[opiCheckInDate]
	  ,[token]
	  ,[posResponse]
  FROM [dbo].[Opi]
  INNER JOIN (
	SELECT [OriginalId]
		,MAX([Id]) AS [Id]
	FROM [dbo].[Opi]
	WHERE [authorizedAmount] != 0.00
	AND ([OriginalId] = @OriginalId OR [Id] = @OriginalId)
	GROUP BY [OriginalId]
	) A ON [Opi].[Id] = A.[Id]
GO


if exists (select * from sys.procedures where name = N'Opi_GetLastNonCaptureByOriginalId')
	drop procedure  [dbo].[Opi_GetLastNonCaptureByOriginalId]
GO

CREATE PROCEDURE [dbo].[Opi_GetLastNonCaptureByOriginalId]
(
	@OriginalId BIGINT
)
AS
SELECT [Opi].[Id]
	  ,[Opi].[OriginalId]
	  ,[SequenceNo]
	  ,[folioNumber]
	  ,[dateUtc]
	  ,[freewayRequestId]
	  ,[allowIncrAuth]
	  ,[amount]
	  ,[authorizedAmount]
	  ,[capturedAmount]
	  ,[opiTransType]
	  ,[opiCheckInDate]
	  ,[token]
	  ,[posResponse]
  FROM [dbo].[Opi]
  INNER JOIN (
	SELECT [OriginalId]
		,MAX([Id]) AS [Id]
	FROM [dbo].[Opi]
	WHERE [authorizedAmount] != 0.00 
	AND [capturedAmount] = 0.00
	AND [OriginalId] = @OriginalId
	GROUP BY [OriginalId]
	) A ON [Opi].[Id] = A.[Id]

GO

if exists (select * from sys.procedures where name = N'Opi_GetLastByValues')
	drop procedure  [dbo].[Opi_GetLastByValues]
GO

CREATE PROCEDURE [dbo].[Opi_GetLastByValues]
(
	@folioNumber VARCHAR(50) = NULL,
	@token VARCHAR(50) = NULL
)
AS
SELECT [Opi].[Id]
	  ,[Opi].[OriginalId]
	  ,[SequenceNo]
	  ,[folioNumber]
	  ,[dateUtc]
	  ,[freewayRequestId]
	  ,[allowIncrAuth]
	  ,[amount]
	  ,[authorizedAmount]
	  ,[capturedAmount]
	  ,[opiTransType]
	  ,[opiCheckInDate]
	  ,[token]
	  ,[posResponse]
  FROM [dbo].[Opi]
  INNER JOIN (
	SELECT [OriginalId]
		,MAX([Id]) AS [Id]
	FROM [dbo].[Opi]
	WHERE [authorizedAmount] != 0.00
	AND [OriginalId] = (
		SELECT MAX([OriginalId]) AS [OriginalId]
		FROM [dbo].[Opi]
		WHERE [folioNumber] = @folioNumber
		AND [token] = @token
		)
	GROUP BY [OriginalId]
	) A ON [Opi].[Id] = A.[Id]
GO

if exists (select * from sys.procedures where name = N'Opi_GetLastByFolio')
	drop procedure  [dbo].[Opi_GetLastByFolio]
GO

CREATE PROCEDURE [dbo].[Opi_GetLastByFolio]
(
	@folioNumber VARCHAR(50) = NULL
)
AS
SELECT [Opi].[Id]
	  ,[Opi].[OriginalId]
	  ,[SequenceNo]
	  ,[folioNumber]
	  ,[dateUtc]
	  ,[freewayRequestId]
	  ,[allowIncrAuth]
	  ,[amount]
	  ,[authorizedAmount]
	  ,[capturedAmount]
	  ,[opiTransType]
	  ,[opiCheckInDate]
	  ,[token]
	  ,[posResponse]
  FROM [dbo].[Opi]
  INNER JOIN (
	SELECT [OriginalId]
		,MAX([Id]) AS [Id]
	FROM [dbo].[Opi]
	WHERE [authorizedAmount] != 0.00
	AND [OriginalId] = (
		SELECT MAX([OriginalId]) AS [OriginalId]
		FROM [dbo].[Opi]
		WHERE [folioNumber] = @folioNumber
		)
	GROUP BY [OriginalId]
	) A ON [Opi].[Id] = A.[Id]
GO

if exists (select * from sys.procedures where name = N'Opi_GetLastNonCaptureByValues')
	drop procedure  [dbo].[Opi_GetLastNonCaptureByValues]
GO
CREATE PROCEDURE [dbo].[Opi_GetLastNonCaptureByValues]
(
	@folioNumber VARCHAR(50) = NULL,
	@token VARCHAR(50) = NULL
)
AS
SELECT [Opi].[Id]
	  ,[Opi].[OriginalId]
	  ,[SequenceNo]
	  ,[folioNumber]
	  ,[dateUtc]
	  ,[freewayRequestId]
	  ,[allowIncrAuth]
	  ,[amount]
	  ,[authorizedAmount]
	  ,[capturedAmount]
	  ,[opiTransType]
	  ,[opiCheckInDate]
	  ,[token]
	  ,[posResponse]
  FROM [dbo].[Opi]
  INNER JOIN (
	SELECT [OriginalId]
		,MAX([Id]) AS [Id]
	FROM [dbo].[Opi]
	WHERE [authorizedAmount] != 0.00 
	AND [capturedAmount] = 0.00
	AND [OriginalId] = (
		SELECT MAX([OriginalId]) AS [OriginalId]
		FROM [dbo].[Opi]
		WHERE [folioNumber] = @folioNumber
		AND [token] = @token
		)
	GROUP BY [OriginalId]
	) A ON [Opi].[Id] = A.[Id]
GO

if exists (select * from sys.procedures where name = N'Opi_GetLastBySequenceNo')
	drop procedure  [dbo].[Opi_GetLastBySequenceNo]
GO
CREATE PROCEDURE [dbo].[Opi_GetLastBySequenceNo]
(
	@SequenceNo BIGINT
)
AS
SELECT [Opi].[Id]
	  ,[Opi].[OriginalId]
	  ,[SequenceNo]
	  ,[folioNumber]
	  ,[dateUtc]
	  ,[freewayRequestId]
	  ,[allowIncrAuth]
	  ,[amount]
	  ,[authorizedAmount]
	  ,[capturedAmount]
	  ,[opiTransType]
	  ,[opiCheckInDate]
	  ,[token]
	  ,[posResponse]
  FROM [dbo].[Opi]
  INNER JOIN (
	SELECT [OriginalId]
		,MAX([Id]) AS [Id]
	FROM [dbo].[Opi]
	WHERE [authorizedAmount] != 0.00
	AND [SequenceNo] = @SequenceNo
	GROUP BY [OriginalId]
	) A ON [Opi].[Id] = A.[Id]
GO


if exists (select * from sys.procedures where name = N'Log_DeleteBeforeDate')
	drop procedure  [dbo].[Log_DeleteBeforeDate]
GO
CREATE PROCEDURE [dbo].[Log_DeleteBeforeDate] (
		@deleteDate date
) AS
BEGIN
		delete from [Log] where [startDate] < @deleteDate
END
GO

/*** END CREATE PROCS SECTION ***/